#include <irrlicht.h>
#include <iostream>
#include <list>
#include <WCHAR.H>
#include <ITimer.h>

#include <Windows.h>

#include "enemy.h"

using namespace irr;

#pragma comment(lib, "Irrlicht.lib")
#pragma comment(lib, "Winmm.lib")



std::list<BaseCharacter*> bullet;
std::list<BaseCharacter*>::iterator bulletP;

std::list<BaseCharacter*> enemy;
std::list<BaseCharacter*>::iterator enemyP;

std::list<BaseCharacter*> enemyBullet;
std::list<BaseCharacter*>::iterator enemyBulletP;

std::list<BaseCharacter*> smoke;
std::list<BaseCharacter*>::iterator smokeP;

static float jikix=320, jikiy=240, jikiSpeed=2;
float BaseCharacter::jikix;
float BaseCharacter::jikiy;

static bool left=false, right=false, up=false, down=false;
static bool button1=false, canFire=true;

class MyEventReceiver : public IEventReceiver
{
public:
	virtual bool OnEvent(SEvent event)
	{
		if (event.EventType == irr::EET_KEY_INPUT_EVENT)
		{
			if (event.KeyInput.PressedDown)
			{
				switch(event.KeyInput.Key)
				{
				case KEY_ESCAPE:
					exit(0);

				case KEY_LEFT:
					left = true;
					return true;

				case KEY_RIGHT:
					right=true;
					return true;

				case KEY_UP:
					up=true;
					return true;

				case KEY_DOWN:
					down=true;
					return true;

				case KEY_KEY_Z:
					button1=true;
					return true;
				}
			}
			else
			{
				switch(event.KeyInput.Key)
				{
				case KEY_LEFT:
					left = false;
					return true;

				case KEY_RIGHT:
					right = false;
					return true;

				case KEY_UP:
					up = false;
					return true;

				case KEY_DOWN:
					down = false;
					return true;
				case KEY_KEY_Z:
					button1=false;
					canFire=true;
					return true;
				}
			}
		}

		return false;
	}
};

int main()
{
	MyEventReceiver receiver;

	video::E_DRIVER_TYPE driverType;

	//driverType = video::EDT_SOFTWARE;
	driverType = video::EDT_OPENGL;
	//driverType = video::EDT_DIRECTX8;
	//driverType = video::EDT_DIRECTX9;

	IrrlichtDevice *device = createDevice(driverType,
		core::dimension2d<s32>(640, 480), 16,false,false,false,&receiver);

	if (device == 0)
		return 1;

	device->setWindowCaption(L"iKIwKX gamedev@2ch");

	video::IVideoDriver* driver = device->getVideoDriver();

	video::ITexture* images = driver->getTexture("all256.bmp");
	driver->makeColorKeyTexture(images, core::position2d<s32>(0,0));

	video::ITexture* imagesLogo = driver->getTexture("gamdev.bmp");

	//tHgݒ
	gui::IGUIFont* font = device->getGUIEnvironment()->getBuiltInFont();

	//\摜̐ݒ
	core::rect<s32> jiki1(0,24,15,39);
	core::rect<s32> jiki2(0,40,15,55);
	core::rect<s32> teki(16,72,31,88);
	core::rect<s32> Logo(0,0,449,119);
	core::rect<s32> tama(16,24,31,39);
	core::rect<s32> etama(0,312,8,319);
	core::rect<s32> smokexy0(0,120+(0*32),32,152+(0*32));
	core::rect<s32> smokexy1(0,120+(1*32),32,152+(1*32));
	core::rect<s32> smokexy2(0,120+(2*32),32,152+(2*32));
	core::rect<s32> smokexy3(0,120+(3*32),32,152+(3*32));
	core::rect<s32> smokexy4(0,120+(4*32),32,152+(4*32));
	core::rect<s32> smokexy5(0,120+(5*32),32,152+(5*32));

	//C[v
	while(device->run() && driver)
	{
		static u32 time, beforeTime, tpf;
		time = device->getTimer()->getTime();
		tpf = (time - beforeTime);

		if (device->isWindowActive() && tpf > 16)
		{

			driver->beginScene(true, true, video::SColor(0,120,102,136));

			JOYINFO ji;
			if ( joyGetPos( 0, &ji ) != JOYERR_UNPLUGGED )
			{
		//		if(ji.wButtons & (1<<8))
				if( (ji.wButtons & 0x0F) == 0x0F )
				return 1;
			}

			// L[씽f
			if (left && jikix > 0)
				jikix-=jikiSpeed;
			if (right && jikix < 639-16)
				jikix+=jikiSpeed;
			if (up && jikiy > 0)
				jikiy-=jikiSpeed;
			if (down && jikiy <479-16)
				jikiy+=jikiSpeed;


			CEnemySnake::jikix=jikix;
			CEnemySnake::jikiy=jikiy;

			//e
//			if (button1 && canFire)
			static int BetweenFire;
			if (button1 && BetweenFire-- == 0)
			{
				bullet.push_back(new Character(jikix,jikiy) );
				//canFire=false;
				BetweenFire=10;
			}

			//eړ
			for (bulletP = bullet.begin() ; bulletP != bullet.end() ; bulletP++)
			{
				(*bulletP)->y-=4;
				if ( (*bulletP)->y < 0 )
				{
					(*bulletP)->kill = true;
				}
			}

			//@eƓG̓蔻
			for (bulletP = bullet.begin() ; bulletP != bullet.end() ; bulletP++)
			{
				bool isKill; //eȂɂɓ
				isKill=false;
				//Gړ
				for (enemyP = enemy.begin() ; enemyP != enemy.end() ; enemyP++)
				{
					if ( abs( (*bulletP)->x - (*enemyP)->x) < 16 &&
						abs( (*bulletP)->y - (*enemyP)->y) < 16 )
					{
						smoke.push_back(new Character( (*enemyP)->x-8, (*enemyP)->y-8) );
						(*enemyP)->kill = true;
						isKill=true;
					}
				}

				if ( isKill == true )
				{
					(*bulletP)->kill = true;
				}
			}

			//G
			static int SpawnCount=100;
			if (--SpawnCount == 0)
			{
				static EnemyMode=0;
				if (++EnemyMode > 10)
					EnemyMode=0;

				if (EnemyMode < 5)
				{
					enemy.push_back(new CEnemy(jikix,0) );
				}
				else if (EnemyMode < 10)
				{
					enemy.push_back(new CEnemyStraight(float(rand() % 639),0) );
				}
				else if (EnemyMode == 10)
				{
					CEnemySnake *EnemySnake = new CEnemySnake(float(rand() % 639), -16, NULL);
					enemy.push_back(EnemySnake);
					for (int i=0 ; i<10 ; i++)
					{
						EnemySnake = new CEnemySnake(EnemySnake->x, EnemySnake->y-16, EnemySnake);
						enemy.push_back(EnemySnake);
					}
				}

				SpawnCount=100;
			}

			//Gړ
			for (enemyP = enemy.begin() ; enemyP != enemy.end() ; enemyP++)
			{
				(*enemyP)->move();
				if ( (*enemyP)->y >479)
				{
					(*enemyP)->kill = true;
				}
			}

			//GƎ@̓蔻
			for (enemyP = enemy.begin() ; enemyP != enemy.end() ; enemyP++)
			{
				if ( abs( jikix - (*enemyP)->x) < 8 &&
					abs( jikiy - (*enemyP)->y) < 8 )

				smoke.push_back(new Character( jikix-8, jikiy-8) );
			}

			//Ge
			for (enemyP = enemy.begin() ; enemyP != enemy.end() ; enemyP++)
			{
				static int enemyBulletSpawnCount=266;
				if (--enemyBulletSpawnCount == 0)
				{
					enemyBullet.push_back(new CBullet( (*enemyP)->x+4,(*enemyP)->y+4, jikix+8, jikiy+8));
					enemyBulletSpawnCount=266;
					
				}
			}

			//Geړ
			for (enemyBulletP = enemyBullet.begin() ; enemyBulletP != enemyBullet.end() ; enemyBulletP++)
			{
				(*enemyBulletP)->move();
				if ( (*enemyBulletP)->kill)
				{
					(*enemyBulletP)->kill = true;
				}
			}

			//GeƎ@̓蔻
			for (enemyBulletP = enemyBullet.begin() ; enemyBulletP != enemyBullet.end() ; enemyBulletP++)
			{
				if ( abs( jikix - (*enemyBulletP)->x) < 8 &&
					abs( jikiy - (*enemyBulletP)->y) < 8 )

				smoke.push_back(new Character( jikix-8, jikiy-8) );
			}



			//S\
			static LogoY=-120;
			if (++LogoY > 479)
				LogoY=-120;
			driver->draw2DImage(imagesLogo, core::position2d<s32>(0,LogoY),
				Logo, 0, 
				video::SColor(255,255,255,255), true);

			// @`
			driver->draw2DImage(images, core::position2d<s32>((int)jikix,(int)jikiy),
				(time/500 % 2) ? jiki1 : jiki2, 0, 
				video::SColor(255,255,255,255), true);

			//e`
			for (bulletP = bullet.begin() ; bulletP != bullet.end() ; bulletP++)
			{
				driver->draw2DImage(images, core::position2d<s32>(int((*bulletP)->x),int((*bulletP)->y)),
					tama , 0, 
					video::SColor(255,255,255,255), true);
			}

			//G`
			for (enemyP = enemy.begin() ; enemyP != enemy.end() ; enemyP++)
			{
				driver->draw2DImage(images, core::position2d<s32>(int((*enemyP)->x),int((*enemyP)->y)),
					teki , 0, 
					video::SColor(255,255,255,255), true);
			}

			//Ge`
			for (enemyBulletP = enemyBullet.begin() ; enemyBulletP != enemyBullet.end() ; enemyBulletP++)
			{
				driver->draw2DImage(images, core::position2d<s32>(int((*enemyBulletP)->x),int((*enemyBulletP)->y)),
					etama , 0, 
					video::SColor(255,255,255,255), true);
			}

			//`
			for (smokeP = smoke.begin() ; smokeP != smoke.end() ; smokeP++)
			{
				switch ((*smokeP)->imageNumber++)
				{
				case 0:
					driver->draw2DImage(images, core::position2d<s32>(int((*smokeP)->x),int((*smokeP)->y)),smokexy0 , 0,video::SColor(255,255,255,255), true);
					break;
				case 1:
					driver->draw2DImage(images, core::position2d<s32>(int((*smokeP)->x),int((*smokeP)->y)),smokexy1 , 0,video::SColor(255,255,255,255), true);
					break;
				case 2:
					driver->draw2DImage(images, core::position2d<s32>(int((*smokeP)->x),int((*smokeP)->y)),smokexy2 , 0,video::SColor(255,255,255,255), true);
					break;
				case 3:
					driver->draw2DImage(images, core::position2d<s32>(int((*smokeP)->x),int((*smokeP)->y)),smokexy3 , 0,video::SColor(255,255,255,255), true);
					break;
				case 4:
					driver->draw2DImage(images, core::position2d<s32>(int((*smokeP)->x),int((*smokeP)->y)),smokexy4 , 0,video::SColor(255,255,255,255), true);
					break;
				case 5:
					driver->draw2DImage(images, core::position2d<s32>(int((*smokeP)->x),int((*smokeP)->y)),smokexy5 , 0,video::SColor(255,255,255,255), true);
					break;
				case 6:
					(*smokeP)->kill = true;
					break;
				}
			}

			// eLXg\
			if (font)
			font->draw(L"gamedev@2ch", 
				core::rect<s32>(580,470,640,480),
				video::SColor(255,255,255,255));

			//GAeȂǃfobOp\
			wchar_t str[100];
			swprintf (str, 100, L"bullet %d", bullet.size());  
			font->draw(str, core::rect<s32>(0,240,640,480), video::SColor(255,255,255,255));
			swprintf (str, 100, L"enemy %d", enemy.size());  
			font->draw(str, core::rect<s32>(0,256,640,480), video::SColor(255,255,255,255));
			swprintf (str, 100, L"enemyBullet %d", enemyBullet.size());  
			font->draw(str, core::rect<s32>(0,272,640,480), video::SColor(255,255,255,255));
			swprintf (str, 100, L"smoke %d", smoke.size());  
			font->draw(str, core::rect<s32>(0,288,640,480), video::SColor(255,255,255,255));

			swprintf (str, 100, L"TPF %d", tpf );  
			font->draw(str, core::rect<s32>(0,304,640,480), video::SColor(255,255,255,255));
			beforeTime = time;
			
			driver->endScene();

			
			
			//killtȌ
			for (bulletP = bullet.begin() ; bulletP != bullet.end() ; bulletP++)
			{
				if ( (*bulletP)->kill)
				{
					delete(*bulletP);
					bulletP=bullet.erase(bulletP);
				}
			}

			for (enemyP = enemy.begin() ; enemyP != enemy.end() ; enemyP++)
			{
				if ( (*enemyP)->kill )
				{
					delete(*enemyP);
					enemyP=enemy.erase(enemyP);
				}
			}

			for (enemyBulletP = enemyBullet.begin() ; enemyBulletP != enemyBullet.end() ; enemyBulletP++)
			{
				if ( (*enemyBulletP)->kill )
				{
					delete(*enemyBulletP);
					enemyBulletP=enemyBullet.erase(enemyBulletP);
				}
			}

			for (smokeP = smoke.begin() ; smokeP != smoke.end() ; smokeP++)
			{
				if ( (*smokeP)->kill )
				{
					delete(*smokeP);
					smokeP=smoke.erase(smokeP);
				}
			}

		}
	}

	device->drop();

	return 0;
}
